Subject: Re: [PATCH ethtool-next] netlink: tsconfig: add HW time stamping configuration

From: Vadim Fedorenko <[email-masked]>
Date: Wed, 29 Oct 2025 18:53:20 +0000

On 29/10/2025 16:26, Michal Kubecek wrote:
> On Tue, Oct 28, 2025 at 09:48:00PM GMT, Vadim Fedorenko wrote:
>> On 26/10/2025 16:57, Michal Kubecek wrote:
>>> On Sat, Oct 04, 2025 at 08:27:15PM GMT, Vadim Fedorenko wrote:
>>>> The kernel supports configuring HW time stamping modes via netlink
>>>> messages, but previous implementation added support for HW time stamping
>>>> source configuration. Add support to configure TX/RX time stamping.
>>>>
>>>> Signed-off-by: Vadim Fedorenko <[email-masked]>
>>>
>>> As far as I can see, you only allow one bit to be set in each of
>>> ETHTOOL_A_TSCONFIG_TX_TYPES and ETHTOOL_A_TSCONFIG_RX_FILTERS. If only
>>> one bit is supposed to be set, why are they passed as bitmaps?
>>> (The netlink interface only mirrors what (read-only) ioctl interface
>>> did.)
>>
>> Well, yes, it's only 1 bit is supposed to be set. Unfortunately, netlink
>> interface was added this way almost a year ago, we cannot change it
>> anymore without breaking user-space API.
> 
> The netlink interface only mirrors what we already had in struct
> ethtool_ts_info (i.e. the ioctl interface). Therefore my question was
> not really about this part of kernel API (which is fixed already) but
> rather about the ethtool command line syntax.
> 
> In other words, what I really want to ask is: Can we be absolutely sure
> that it can never possibly happen in the future that we might need to
> set more than one bit in a set message?
> 
> If the answer is positive, I'm OK with the patch but perhaps we should
> document it explicitly in the TSCONFIG_SET description in kernel file
> Documentation/networking/ethtool-netlink.rst

Well, I cannot say about long-long future, but for the last decade we
haven't had a need for multiple bits to be set up. I would assume that
the reality will be around the same.

Jakub/Kory do you have thoughts?